//+------------------------------------------------------------------+
//|                                              Supermathprofit.mq4 |
//|                      Copyright  2012, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 DodgerBlue
#property indicator_color2 Red
#property indicator_color3 DodgerBlue
#property indicator_color4 Red
#property indicator_color5 DodgerBlue
#property indicator_color6 Red

extern int Per_1 = 6;
extern int Per_2 = 2;
extern int MM = 1;
extern int ma_st1 = 1;
extern int ma_st2 = 1;
extern int repbars = 1000;
extern int SL_pips = 20;
double lets_1[];
double lets_2[];
double lets_3[];
double bets_3[];
double bets_2[];
double bets_1[];
extern bool AlertON = TRUE;
extern bool Email = TRUE;
bool inverse = FALSE;
bool converse = FALSE;
datetime Timer;

// AA82CF3A41CEBBF1D981F099A58AD043
void Funk_1(string bird_1, double bird_2, double bird_3, double bird_4) {
   string mod_01;
   string mod_02;
   string mod_03;
   string mod_04;
   string mod_05;
   if (Time[0] != Timer) {
      Timer = Time[0];
      if (bird_4 != 0.0) mod_03 = " at price " + DoubleToStr(bird_4, 4);
      else mod_03 = "";
      if (bird_2 != 0.0) mod_02 = ", TakeProfit on " + DoubleToStr(bird_2, 4);
      else mod_02 = "";
      if (bird_3 != 0.0) mod_01 = ", StopLoss on " + DoubleToStr(bird_3, 4);
      else mod_01 = "";
      Alert("math " + bird_1 + mod_03 + mod_02 + mod_01 + " ", Symbol(), ", ", Period(), " minutes chart");
      mod_04 = "math " + bird_1 + mod_03;
      mod_05 = "math " + bird_1 + mod_03 + mod_02 + mod_01 + " " + Symbol() + ", " + Period() + " minutes chart";
      if (Email) SendMail(mod_04, mod_05);
   }
}

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   SetIndexBuffer(0, lets_1);
   SetIndexBuffer(1, lets_2);
   SetIndexBuffer(2, lets_3);
   SetIndexBuffer(3, bets_3);
   SetIndexBuffer(4, bets_2);
   SetIndexBuffer(5, bets_1);
   SetIndexStyle(0, DRAW_NONE, STYLE_DASH, 2);
   SetIndexStyle(1, DRAW_NONE, STYLE_DASH, 2);
   SetIndexStyle(2, DRAW_ARROW, STYLE_DASH, 4);
   SetIndexStyle(3, DRAW_ARROW, STYLE_DASH, 4);
   SetIndexStyle(4, DRAW_NONE, STYLE_DASH, 2);
   SetIndexStyle(5, DRAW_NONE, STYLE_DASH, 2);
   SetIndexArrow(0, 159);
   SetIndexArrow(1, 159);
   SetIndexArrow(2, SYMBOL_ARROWUP);
   SetIndexArrow(3, SYMBOL_ARROWDOWN);
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS));
   string supmatpro = "math(" + AlertON + "," + Per_2 + ")";
   IndicatorShortName(supmatpro);
   SetIndexLabel(0, "");
   SetIndexLabel(1, "");
   SetIndexLabel(2, "");
   SetIndexLabel(3, "");
   SetIndexLabel(4, "");
   SetIndexLabel(5, "");
   SetIndexDrawBegin(0, Per_1);
   SetIndexDrawBegin(1, Per_1);
   SetIndexDrawBegin(2, Per_1);
   SetIndexDrawBegin(3, Per_1);
   SetIndexDrawBegin(4, Per_1);
   SetIndexDrawBegin(5, Per_1);
   return (0);
}

// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   int ken_1;
   double Dek01[25000];
   double Dek02[25000];
   double Dek03[25000];
   double Dek04[25000];
   double Dek05;
   double closer;
   for (int shift_r = repbars; shift_r > 0; shift_r--) {
      lets_1[shift_r] = 0;
      lets_2[shift_r] = 0;
      lets_3[shift_r] = 0;
      bets_3[shift_r] = 0;
      bets_2[shift_r] = EMPTY_VALUE;
      bets_1[shift_r] = EMPTY_VALUE;
   }
   for (shift_r = repbars - Per_1 - 1; shift_r > 0; shift_r--) {
      Dek01[shift_r] = iBands(NULL, 0, Per_1, Per_2, 0, PRICE_CLOSE, MODE_UPPER, shift_r);
      Dek02[shift_r] = iBands(NULL, 0, Per_1, Per_2, 0, PRICE_CLOSE, MODE_LOWER, shift_r);
      if (Close[shift_r] > Dek01[shift_r + 1]) ken_1 = 1;
      if (Close[shift_r] < Dek02[shift_r + 1]) ken_1 = -1;
      if (ken_1 > 0 && Dek02[shift_r] < Dek02[shift_r + 1]) Dek02[shift_r] = Dek02[shift_r + 1];
      if (ken_1 < 0 && Dek01[shift_r] > Dek01[shift_r + 1]) Dek01[shift_r] = Dek01[shift_r + 1];
      Dek03[shift_r] = Dek01[shift_r] + (MM - 1) / 2.0 * (Dek01[shift_r] - Dek02[shift_r]);
      Dek04[shift_r] = Dek02[shift_r] - (MM - 1) / 2.0 * (Dek01[shift_r] - Dek02[shift_r]);
      if (ken_1 > 0 && Dek04[shift_r] < Dek04[shift_r + 1]) Dek04[shift_r] = Dek04[shift_r + 1];
      if (ken_1 < 0 && Dek03[shift_r] > Dek03[shift_r + 1]) Dek03[shift_r] = Dek03[shift_r + 1];
      if (ken_1 > 0) {
         if (ma_st1 > 0 && lets_1[shift_r + 1] == -1.0) {
            lets_3[shift_r] = Dek04[shift_r];
            lets_1[shift_r] = Dek04[shift_r];
            if (ma_st2 > 0) bets_2[shift_r] = Dek04[shift_r];
            if (AlertON == TRUE && shift_r == 1 && (!inverse)) {
               Dek05 = Low[1];
               if (Low[2] < Dek05) Dek05 = Low[2];
               if (Low[3] < Dek05) Dek05 = Low[3];
               if (Low[4] < Dek05) Dek05 = Low[4];
               Dek05 -= SL_pips * Point;
               closer = Close[1];
               Funk_1("Buy SUPERMATHPROFIT", 0, Dek05, closer);
               inverse = TRUE;
               converse = FALSE;
            }
         } else {
            lets_1[shift_r] = Dek04[shift_r];
            if (ma_st2 > 0) bets_2[shift_r] = Dek04[shift_r];
            lets_3[shift_r] = -1;
         }
         if (ma_st1 == 2) lets_1[shift_r] = 0;
         bets_3[shift_r] = -1;
         lets_2[shift_r] = -1.0;
         bets_1[shift_r] = EMPTY_VALUE;
      }
      if (ken_1 < 0) {
         if (ma_st1 > 0 && lets_2[shift_r + 1] == -1.0) {
            bets_3[shift_r] = Dek03[shift_r];
            lets_2[shift_r] = Dek03[shift_r];
            if (ma_st2 > 0) bets_1[shift_r] = Dek03[shift_r];
            if (AlertON == TRUE && shift_r == 1 && (!converse)) {
               Dek05 = High[1];
               if (High[2] > Dek05) Dek05 = High[2];
               if (High[3] > Dek05) Dek05 = High[3];
               if (High[4] > Dek05) Dek05 = High[4];
               Dek05 += SL_pips * Point;
               closer = Close[1];
               Funk_1("Sell SUPERMATHPROFIT", 0, Dek05, closer);
               converse = TRUE;
               inverse = FALSE;
            }
         } else {
            lets_2[shift_r] = Dek03[shift_r];
            if (ma_st2 > 0) bets_1[shift_r] = Dek03[shift_r];
            bets_3[shift_r] = -1;
         }
         if (ma_st1 == 2) lets_2[shift_r] = 0;
         lets_3[shift_r] = -1;
         lets_1[shift_r] = -1.0;
         bets_2[shift_r] = EMPTY_VALUE;
      }
   }
   return (0);
}